/*
  Name: Compiler.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: This is the compiler for Mercenary Soldier Script
*/

#ifndef COMPILER_MSS
#define COMPILER_MSS

#include <string>

//Byte code tokens
enum tokens
{
	//Standard tokens
	EVENT = 1,
	IF = 8,
	IFN = 9,
	SET = 3,
	INC = 4,
	DEC = 5,
	ADD = 6,
	SUB = 7,
	MSG = 10,
	ENDL = 11,
	MSGVAR = 12,
	GRAPHIC = 13,
	GOTO = 14,
	QUIT = 17,
	QUITN = 18,
	QUITA = 19,
	LOADSOUND = 20,
	DELETESOUND = 21,
	PLAYSOUND = 22,
	STOPSOUND = 23,
	SMALLER = 24,
	EQUAL = 25,
	MUL = 26,
	DIV = 27,
	MSGKEY = 28,
	JMPIF = 29,
	JMPIFN = 30,
	//Tokens that tell the VM if the value is variable or a constant int
	ISVAR = 15,
	ISNUM = 16,
	//End tokens
	EVENTEND = 254,
	IFEND = 253,
	SCRIPTEND = 255,
};

//Event values
enum events
{
	ONENTER = 1,
	ONLEAVE = 2,
	ONEXPLODE = 3,
	DURINGTOUCH = 4,
	ONKILL = 5,
	ONLOAD = 6,
	ONUSE = 7,
	ONCALL = 8,
	GLOBAL = 9,
};

const int STARTSIZE  = 64,
ADDRESSRANGE = 128,
PROTECTEDRANGE  = 16;

bool compile(std::string inputPath, std::string outputPath, unsigned char *output = NULL, int *outputSize = NULL);

#endif
