/*
  Name: Entity.cpp
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: The entity class is the parent class of all Objects visible ingame
*/

#include <allegro.h>
#include <libnet.h>

#include "Entity.h"
#include "Global.h"

Entity::Entity()
{
	posX = 0.0;
	posY = 0.0;
	direction = 0;
	curState = 0;
	radius = 0;
	AIstate = STATE_STANDBY;
}

Entity::~Entity()
{
#if 0
	for(int i = 0; i < MAXSPRITES; ++i)
	{
		if(!destroy)
			break;
		if(sprites[i])
			destroy_bitmap(sprites[i]);
	}
	delete [] sprites;
#endif
}

#if 0
void Entity::draw(int cameraX, int cameraY)
{
	//if(int(posX) > cameraX || int(posY) > cameraY || int(posX) + sprites[curState]->w < cameraX || int(posY) + sprites[curState]->h < cameraY)
	//{
	//	return;
	//}
	rotate_sprite(global.doublebuffer, sprites[curState], int(posX) - cameraX - sprites[curState]->w / 2, int(posY) - cameraY - sprites[curState]->h / 2, itofix(direction));
	//rotate_sprite(global.doublebuffer, sprites[curState], int(posX) - cameraX, int(posY) - cameraY, itofix(direction));
}
#endif

int Entity::getRadius()
{
	return radius;
}

int &Entity::getState()
{
	return curState;
}

int &Entity::getAIState()
{
	return AIstate;
}

int &Entity::getDirection()
{
	return direction;
}

float &Entity::getFlPosX()
{
	return posX;
}

float &Entity::getFlPosY()
{
	return posY;
}

int Entity::getPosX()
{
	return int(posX);
}

int Entity::getPosY()
{
	return int(posY);
}
