/*
  Name: SPmapClass.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: This is the map class for SP games, it's derived from
    the mapClass class
*/

#ifndef SP_MAPCLASS_DEF
#define SP_MAPCLASS_DEF

#include <allegro.h>
#include <string>
#include <fstream>

#include "mapClass.h"
#include "bytecode.h"
#include "VM.h"
#include "Global.h"
#include "requests.h"

class SPmapClass : public mapClass
{
private:
	BITMAP *preview;
	int smallSize;

	//Script code for all events
	bytecode **onEnter;
	bytecode **onLeave;
	bytecode **duringTouch;
	bytecode **onExplode;
	bytecode **onUse;
public:
	inline SPmapClass() : mapClass()
	{
		onEnter = NULL;
		onLeave = NULL;
		onExplode = NULL;
		onUse = NULL;
		duringTouch = NULL;
		preview = NULL;
	}
	~SPmapClass();
	void loadMap(std::ifstream &readfile, std::string filename, char mapType, VirtualMachine &VM);
	//Function to handle moving requests
	void handleMoveRequest(moveRequest *mReq, VirtualMachine &VM, int onUse);

	BITMAP *getMapPreview(int sizeX, int sizeY);
	int getSmallSize();
};

#endif
