/*
  Name: bullet.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: The bullet class is derived from the Entity class,
        every bullet shot in the game has an entity of this class
*/

#ifndef BULLETCLASS
#define BULLETCLASS

#include "Entity.h"
#include "requests.h"
#include "Sound.h"

extern BITMAP *bulletSprites[WEAPONTYPES];
extern Sound bulletSounds[WEAPONTYPES];

class bullet : public Entity
{
private:
	int type;
	int moved;
	bool active;
	void *team;
	//An array of BITMAP pointers
//	BITMAP **sprites;
	//Only destroy bitmaps if this is true
//	bool destroy;
public:
	bullet();
	~bullet();
	void init(int initType, int dir, float initPosX, float initPosY, void *iTeam, bool immune);
	moveRequest *update();
	bool returnRequest(moveRequest *mReq);
	void draw(int cameraX, int cameraY);
	bool isActive();

	int getType();
	void *getTeam();
};

#endif
