/*
  Name: mouse.cpp
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: 03.07.05 23:22
  Description: Mouse routines
*/

#include <allegro.h>
#include "mouse.h"
#include "Global.h"

bool down = false;
bool click = false;
int clickPosX = 0;
int clickPosY = 0;
int oldMouseZ = mouse_z;
int mouseZDiff = 0;

void mouseCallback(int flag);

void installMouse()
{
	//mouse_callback = mouseCallback;
}

void mouseCallback(int flag)
{
	click = false;
	mouseZDiff = mouse_z - oldMouseZ;
	oldMouseZ = mouse_z;
	if(mouse_b & 0x01 && !down)
	{
		down = true;
		clickPosX = mouse_x;
		clickPosY = mouse_y;
	}
	else if(down && !(mouse_b & 0x01))
	{
	    down = false;
	    if(clickPosX == mouse_x && clickPosY == mouse_y)
	        click = true;
	}
}

bool clickEvent()
{
	if(click)
	{
		click = false;
		return true;
	}
	return false;
}

void drawMouse()
{
	masked_blit(mouse_sprite, global.doublebuffer, 0, 0, mouse_x, mouse_y, mouse_sprite->w, mouse_sprite->h);
}

bool wheelUpEvent()
{
	if(mouseZDiff > 0)
		return true;
	return false;
}

bool wheelDownEvent()
{
	if(mouseZDiff < 0)
	    return true;
	return false;
}
