/*
  Name: mpUnit.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: This class is used for the multiplayer mode on server side
*/

#ifndef MP_PLAYER_UNIT
#define MP_PLAYER_UNIT

#include <libnet.h>
#include <string>
#include "Entity.h"

class mpUnit : public Entity
{
private:
	int points;
	bool active;
	int maxLife, life;
	int maxArmor, armor;
	//Needed for animating the run animation
	int phase;
	//Needed for blood animation
	int respawnTime;

	//Time before Unit can shoot again
	int shootCooldown;

	int ammo[4];

	//Connection
	NET_CONN *connection;
public:
	mpUnit();
	~mpUnit();
	void respawn(float spawnPosX, float spawnPosY, int spawnDir);
	void moveTo(float newPosX, float newPosY);
	void poll();
	void leaveServer();
	bool isActive();
	void getHit(int bulletType);
	bool isAlife();
	void getConnected(NET_CONN *newconn);
	int receivePacket(char *buffer, int packetMaxSize);
	NET_CONN *getConnection();
	int &getPoints();
	int &getPhase();
	
	std::string name;
};

#endif
