/*
  Name: mpcUnit.cpp
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: This unit type is used on the client side of MP games
*/

#include <allegro.h>
#include <string>
using namespace std;

#include "mpcUnit.h"
#include "Global.h"
#include "mpRequest.h"

const int SPRCOLORS[MAXSPRITES] = { makecol32(0xFF, 0xFF, 0xFF), 0,
makecol32(0xFF, 0x00, 0x00), makecol32(0x00, 0xFF, 0x00), makecol32(0x00, 0x00, 0xFF), };

void mpcUnit::setSprites(BITMAP **sprites)
{
	bitmaps = sprites;
}

mpcUnit::mpcUnit()
{
    active = false;
    phase = 0;
}

bool mpcUnit::isActive()
{
	return active;
}

void mpcUnit::join(string sname, int spoints)
{
	active = true;
	name = sname;
	points = spoints;
}

void mpcUnit::leave()
{
	active = false;
	name.erase();
}

int mpcUnit::getPoints()
{
	return points;
}

void mpcUnit::draw(int camX, int camY, int myID)
{
	if(active)
	{
		//rectfill(global.doublebuffer, int(posX) - camX - 10, int(posY) - camY - 10, int(posX) - camX + 10, int(posY) - camY + 10, SPRCOLORS[myID]);
		//rotate_sprite(global.doublebuffer, bitmaps[curState], int(posX) - camX - bitmaps[curState]->w / 2, int(posY) - camY - bitmaps[curState]->h / 2, itofix(direction));
		if(phase > 8)
			rotate_sprite_v_flip(global.doublebuffer, bitmaps[curState], int(posX) - camX - bitmaps[curState]->w / 2, int(posY) - camY - bitmaps[curState]->h / 2, itofix(direction + 128));
		else
			rotate_sprite(global.doublebuffer, bitmaps[curState], int(posX) - camX - bitmaps[curState]->w / 2, int(posY) - camY - bitmaps[curState]->h / 2, itofix(direction));
	}
}

string mpcUnit::getName()
{
	return name;
}

int &mpcUnit::getPhase()
{
	return phase;
}

void mpcUnit::updatePhase()
{
	++phase &= 15;
}
