/*
  Name: packet.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: This class is used to send and receive packets
*/

#ifndef PACKET_DEFINITIONS
#define PACKET_DEFINITIONS

#include <libnet.h>

enum
{
	P_REQUEST,
	P_ACCEPT,
	P_FULL,
	P_VERSIONMISMATCH,
	P_NEWPLAYER,
	P_PLAYERLEFT,
	P_SERVERSHUTDOWN,
	P_NOP,
	P_MOVEREQ,
	P_POSUPDATE,
};

class packet
{
private:
	char *buffer;
	int pos;
	int bufSize;
public:
	packet();
	~packet();
	void put(const char toPut);
	void write(const char *data, const int length);
	void send(NET_CONN *connection);
	int receive(NET_CONN *connection);
	char get();
	void read(char *data, const int length);
	void reset();
	inline char peak() { return buffer[pos]; }
};

#endif
