/*
  Name: requests.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: All kinds of requests that are handed from Entities to the map
*/

#ifndef REQUESTS
#define REQUESTS

enum scriptTypes
{
	SCRIPT_PLAYER = 1,
	SCRIPT_USE = 2,
	SCRIPT_EXPLODE = 4,
};

enum rightTypes
{
	RIGHT_LOW = 1,
	RIGHT_MIDDLE = 2,
	RIGHT_HIGH = 3,
	RIGHT_VERYHIGH = 4,
};

class moveRequest
{
private:
	float oldPosX, oldPosY;
	float newPosX, newPosY;
	int fScripts;
	int fRights;
	int radius;
	bool requested;
	bool declined;
public:
	void set(float oPosX, float oPosY, float nPosX, float nPosY, int scripts, int rights, int rad);
	void set(float oPosX, float oPosY, float nPosX, float nPosY, int scripts, int rights, int rad, bool requestet);
	void decline();
	void declineX();
	void declineY();
	float getOldPosX();
	float getOldPosY();
	float getNewPosX();
	float getNewPosY();
	int getScripts();
	int getRights();
	int getRadius();
	bool wasRequested();
	bool wasDeclined();
};

class bulletRequest
{
private:
	float posX, posY;
	int dir;
	int weaponType;
	void *creator;
public:
	bulletRequest();
	void set(float posX, float posY, int direction, int type, void *team);
	float getPosX();
	float getPosY();
	int getDir();
	int getType();
	void *getTeam();
};

#endif
